//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
int httpd (char*,int *);

#include <webpage.h>

int httpd (char* buffer,int *bufferlen)
{	
	//Einlesen des TCP Socket
	unsigned int	TCP_Socket = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];
	
	for (int a=0;a<10;a++)
		{
		//berprft HTTP Header 
		if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 1)
			{
			unsigned int result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
			pointerold = Page1;
			for (int a = result16;a < (result16 +20);a++)
			{
			if (buffer[a] == '1' && buffer[a + 1] == '=' && buffer[a + 2] == '1')
				{
				if (bit_is_set(PORTB,0))
					{
					PORTB = 0;
					}
					else
					{
					PORTB = 1;
					}
				}
			if (buffer[a] == 'u' 
				&& buffer[a + 1] == 'l' 
				&& buffer[a + 2] == 'r'
				&& buffer[a + 3] == 'i'
				&& buffer[a + 4] == 'c'
				&& buffer[a + 5] == 'h'
				&& buffer[a + 6] == '.'
				&& buffer[a + 7] == 'j'
				&& buffer[a + 8] == 'p'
				&& buffer[a + 9] == 'g')
				{
				pointerold = Page2;
				}	
			if (buffer[a] == 'u' 
				&& buffer[a + 1] == 'l' 
				&& buffer[a + 2] == 'r'
				&& buffer[a + 3] == 'i'
				&& buffer[a + 4] == 'c'
				&& buffer[a + 5] == 'h'
				&& buffer[a + 6] == '1'
				&& buffer[a + 7] == '.'
				&& buffer[a + 8] == 'j'
				&& buffer[a + 9] == 'p'
				&& buffer[a + 10] == 'g')
				{
				pointerold = Page2;
				}	
			}
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//Setzen des Ack Flag
			buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
			//erzeugt HTTP OK Packet
			tcp_add_data (HTTP_OK1,buffer,bufferlen);	
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);
			TCP_Socket_Status[a] = 2;
			TCP_Socket_Pointer[a] = pointerold;
			return(0);
			}
		}
		
	for (int a=0;a<10;a++)
		{
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 2)
			{
				buffer[TCP_HDRFLAGS+1] |= PSH_FLAG;
				//Speichert Sequenzcounter und Aknowledgecounter
				tcp_store(buffer);		
				//erzeugt Seiten Packet
				pointerold = TCP_Socket_Pointer[a];
				tcp_add_data (pointerold,buffer,bufferlen);
				TCP_Socket_Pointer[a] = pointerold;
				//Erzeugt ein TCP Packet 
				tcp_make(buffer);			
				//Sendet das erzeugte TCP Packet 
				Write_Ethernet_Frame (buffer,*bufferlen);	
				if (Sendpage == 0)
					{
					TCP_Socket_Status[a] = 3;
					}
				return (0);		
			}
		}

	for (int a=0;a<10;a++)
		{
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 3)
			{
			TCP_Socket_Store[a] = 0;
			TCP_Socket_Status[a] = 0;
			printf("\nTCP Socket Close %d\n",TCP_Socket);
			TCP_PORT_CLOSE (buffer,bufferlen);
			break;
			}
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 0)
			{
			printf("TCP Socket Open %d\n",TCP_Socket);
			TCP_Socket_Status[a] = 1;
			break;
			}	
		}
return (0);
}


